unit StartupFolder;

{-------------------------------------------------------------------------------

StartCaptor - Controls links and apps automatically started by Windows
Copyright (C) 2000 Adam Stiles.

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

-------------------------------------------------------------------------------}

interface

uses Windows, Sysutils, Registry, ShlObj;

function GetUserStartupFolder: String;
function GetCommonStartupFolder: String;


implementation
//------------------------------------------------------------------------------
// this method uses SHGetSpecialFolderPath API function which only exists
// in IE4.0+ versions of shell32.dll
//------------------------------------------------------------------------------
//function GetFolder(CSIDL: Integer): String;
//var
//  Path: PChar;
//begin
//  Path := StrAlloc(MAX_PATH);
//  SHGetSpecialFolderPath(0, Path, CSIDL, False);
//  Result := Trim(String(Path));
//  StrDispose(Path);
//end;
//------------------------------------------------------------------------------
function GetFolder(CSIDL: Integer): String;
var
  Reg: TRegistry;
  Key: String;
  HK: HKEY;
  Ident: String;
begin
  Result := '';
  Reg := TRegistry.Create;
  try                      
    case CSIDL of
      CSIDL_STARTUP:
        begin
          HK := HKEY_CURRENT_USER;
          Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';
          Ident := 'Startup';
        end;
      CSIDL_COMMON_STARTUP:
        begin
          HK := HKEY_LOCAL_MACHINE;
          Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';
          Ident := 'Common Startup';
        end;
    else
      exit;
    end;

    Reg.RootKey := HK;
    if (Reg.OpenKey(Key, False)) then begin
      Result := Reg.ReadString(Ident);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;
//------------------------------------------------------------------------------
function GetUserStartupFolder: String;
begin
  Result := GetFolder(CSIDL_STARTUP);
end;
//------------------------------------------------------------------------------
function GetCommonStartupFolder: String;
begin
  Result := GetFolder(CSIDL_COMMON_STARTUP);
end;
//------------------------------------------------------------------------------
end.
